// SPDX-License-Identifier: ISC
// Copyright (c) 2014-2020 Bitmark Inc.
// Use of this source code is governed by an ISC
// license that can be found in the LICENSE file.
//

// Code generated by MockGen. DO NOT EDIT.
// Source: github.com/bitmark-inc/bitmarkd/peer/upstream (interfaces: Upstream)

// Package mocks is a generated GoMock package.
package mocks

import (
	reflect "reflect"
	time "time"

	gomock "github.com/golang/mock/gomock"

	blockdigest "github.com/bitmark-inc/bitmarkd/blockdigest"
	util "github.com/bitmark-inc/bitmarkd/util"
	zmqutil "github.com/bitmark-inc/bitmarkd/zmqutil"
)

// MockUpstream is a mock of Upstream interface
type MockUpstream struct {
	ctrl     *gomock.Controller
	recorder *MockUpstreamMockRecorder
}

// MockUpstreamMockRecorder is the mock recorder for MockUpstream
type MockUpstreamMockRecorder struct {
	mock *MockUpstream
}

// NewMockUpstream creates a new mock instance
func NewMockUpstream(ctrl *gomock.Controller) *MockUpstream {
	mock := &MockUpstream{ctrl: ctrl}
	mock.recorder = &MockUpstreamMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use
func (m *MockUpstream) EXPECT() *MockUpstreamMockRecorder {
	return m.recorder
}

// ActiveInThePast mocks base method
func (m *MockUpstream) ActiveInThePast(arg0 time.Duration) bool {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "ActiveInThePast", arg0)
	ret0, _ := ret[0].(bool)
	return ret0
}

// ActiveInThePast indicates an expected call of ActiveInThePast
func (mr *MockUpstreamMockRecorder) ActiveInThePast(arg0 interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ActiveInThePast", reflect.TypeOf((*MockUpstream)(nil).ActiveInThePast), arg0)
}

// CachedRemoteDigestOfLocalHeight mocks base method
func (m *MockUpstream) CachedRemoteDigestOfLocalHeight() blockdigest.Digest {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "CachedRemoteDigestOfLocalHeight")
	ret0, _ := ret[0].(blockdigest.Digest)
	return ret0
}

// CachedRemoteDigestOfLocalHeight indicates an expected call of CachedRemoteDigestOfLocalHeight
func (mr *MockUpstreamMockRecorder) CachedRemoteDigestOfLocalHeight() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CachedRemoteDigestOfLocalHeight", reflect.TypeOf((*MockUpstream)(nil).CachedRemoteDigestOfLocalHeight))
}

// CachedRemoteHeight mocks base method
func (m *MockUpstream) CachedRemoteHeight() uint64 {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "CachedRemoteHeight")
	ret0, _ := ret[0].(uint64)
	return ret0
}

// CachedRemoteHeight indicates an expected call of CachedRemoteHeight
func (mr *MockUpstreamMockRecorder) CachedRemoteHeight() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CachedRemoteHeight", reflect.TypeOf((*MockUpstream)(nil).CachedRemoteHeight))
}

// Connect mocks base method
func (m *MockUpstream) Connect(arg0 *util.Connection, arg1 []byte) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Connect", arg0, arg1)
	ret0, _ := ret[0].(error)
	return ret0
}

// Connect indicates an expected call of Connect
func (mr *MockUpstreamMockRecorder) Connect(arg0, arg1 interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Connect", reflect.TypeOf((*MockUpstream)(nil).Connect), arg0, arg1)
}

// ConnectedTo mocks base method
func (m *MockUpstream) ConnectedTo() *zmqutil.Connected {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "ConnectedTo")
	ret0, _ := ret[0].(*zmqutil.Connected)
	return ret0
}

// ConnectedTo indicates an expected call of ConnectedTo
func (mr *MockUpstreamMockRecorder) ConnectedTo() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ConnectedTo", reflect.TypeOf((*MockUpstream)(nil).ConnectedTo))
}

// Destroy mocks base method
func (m *MockUpstream) Destroy() {
	m.ctrl.T.Helper()
	m.ctrl.Call(m, "Destroy")
}

// Destroy indicates an expected call of Destroy
func (mr *MockUpstreamMockRecorder) Destroy() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Destroy", reflect.TypeOf((*MockUpstream)(nil).Destroy))
}

// GetBlockData mocks base method
func (m *MockUpstream) GetBlockData(arg0 uint64) ([]byte, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetBlockData", arg0)
	ret0, _ := ret[0].([]byte)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// GetBlockData indicates an expected call of GetBlockData
func (mr *MockUpstreamMockRecorder) GetBlockData(arg0 interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetBlockData", reflect.TypeOf((*MockUpstream)(nil).GetBlockData), arg0)
}

// IsConnected mocks base method
func (m *MockUpstream) IsConnected() bool {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "IsConnected")
	ret0, _ := ret[0].(bool)
	return ret0
}

// IsConnected indicates an expected call of IsConnected
func (mr *MockUpstreamMockRecorder) IsConnected() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "IsConnected", reflect.TypeOf((*MockUpstream)(nil).IsConnected))
}

// IsConnectedTo mocks base method
func (m *MockUpstream) IsConnectedTo(arg0 []byte) bool {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "IsConnectedTo", arg0)
	ret0, _ := ret[0].(bool)
	return ret0
}

// IsConnectedTo indicates an expected call of IsConnectedTo
func (mr *MockUpstreamMockRecorder) IsConnectedTo(arg0 interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "IsConnectedTo", reflect.TypeOf((*MockUpstream)(nil).IsConnectedTo), arg0)
}

// LocalHeight mocks base method
func (m *MockUpstream) LocalHeight() uint64 {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "LocalHeight")
	ret0, _ := ret[0].(uint64)
	return ret0
}

// LocalHeight indicates an expected call of LocalHeight
func (mr *MockUpstreamMockRecorder) LocalHeight() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "LocalHeight", reflect.TypeOf((*MockUpstream)(nil).LocalHeight))
}

// Name mocks base method
func (m *MockUpstream) Name() string {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Name")
	ret0, _ := ret[0].(string)
	return ret0
}

// Name indicates an expected call of Name
func (mr *MockUpstreamMockRecorder) Name() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Name", reflect.TypeOf((*MockUpstream)(nil).Name))
}

// RemoteAddr mocks base method
func (m *MockUpstream) RemoteAddr() (string, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "RemoteAddr")
	ret0, _ := ret[0].(string)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// RemoteAddr indicates an expected call of RemoteAddr
func (mr *MockUpstreamMockRecorder) RemoteAddr() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "RemoteAddr", reflect.TypeOf((*MockUpstream)(nil).RemoteAddr))
}

// RemoteDigestOfHeight mocks base method
func (m *MockUpstream) RemoteDigestOfHeight(arg0 uint64) (blockdigest.Digest, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "RemoteDigestOfHeight", arg0)
	ret0, _ := ret[0].(blockdigest.Digest)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// RemoteDigestOfHeight indicates an expected call of RemoteDigestOfHeight
func (mr *MockUpstreamMockRecorder) RemoteDigestOfHeight(arg0 interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "RemoteDigestOfHeight", reflect.TypeOf((*MockUpstream)(nil).RemoteDigestOfHeight), arg0)
}

// RemoteHeight mocks base method
func (m *MockUpstream) RemoteHeight() (uint64, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "RemoteHeight")
	ret0, _ := ret[0].(uint64)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// RemoteHeight indicates an expected call of RemoteHeight
func (mr *MockUpstreamMockRecorder) RemoteHeight() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "RemoteHeight", reflect.TypeOf((*MockUpstream)(nil).RemoteHeight))
}

// ResetServer mocks base method
func (m *MockUpstream) ResetServer() {
	m.ctrl.T.Helper()
	m.ctrl.Call(m, "ResetServer")
}

// ResetServer indicates an expected call of ResetServer
func (mr *MockUpstreamMockRecorder) ResetServer() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ResetServer", reflect.TypeOf((*MockUpstream)(nil).ResetServer))
}

// ServerPublicKey mocks base method
func (m *MockUpstream) ServerPublicKey() []byte {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "ServerPublicKey")
	ret0, _ := ret[0].([]byte)
	return ret0
}

// ServerPublicKey indicates an expected call of ServerPublicKey
func (mr *MockUpstreamMockRecorder) ServerPublicKey() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ServerPublicKey", reflect.TypeOf((*MockUpstream)(nil).ServerPublicKey))
}
